package com.sun.net.httpserver;

import java.util.Base64;
import jdk.Exported;

@Exported
public abstract class BasicAuthenticator extends Authenticator
{
    protected String realm;
    
    public BasicAuthenticator(String realm) {
        this.realm = realm;
    }
    
    public String getRealm() {
        return this.realm;
    }
    
    @Override
    public Authenticator.Result authenticate(HttpExchange httpExchange) {
        String first = httpExchange.getRequestHeaders().getFirst("Authorization");
        if (first == null) {
            httpExchange.getResponseHeaders().set("WWW-Authenticate", "Basic realm=\"" + this.realm + "\"");
            return new Authenticator.Retry(401);
        }
        int index = first.indexOf(32);
        if (index == -1 || !first.substring(0, index).equals("Basic")) {
            return new Authenticator.Failure(401);
        }
        String s = new String(Base64.getDecoder().decode(first.substring(index + 1)));
        int index2 = s.indexOf(58);
        String substring = s.substring(0, index2);
        if (this.checkCredentials(substring, s.substring(index2 + 1))) {
            return new Authenticator.Success(new HttpPrincipal(substring, this.realm));
        }
        httpExchange.getResponseHeaders().set("WWW-Authenticate", "Basic realm=\"" + this.realm + "\"");
        return new Authenticator.Failure(401);
    }
    
    public abstract boolean checkCredentials(String p0, String p1);
}
